import { AppMP } from '../appmp';
import { ViewBase } from '../../libappbase/viewbase';
import { UIWaitSOP } from '../../libappsop/objectsop';
import { FormPurchasingPlan } from '../forms/form.purchasingplan';
import { FormPurchasingPlanDetails } from '../forms/form.purchasingplandetails';

export class ViewPurchasingPlan extends ViewBase implements UIWaitSOP {
  public readonly name = 'Purchasing plan';
  public readonly viewPath = 'Plan > Purchasing Plan';

  public formPurchasingPlan = new FormPurchasingPlan();
  public formPurchasingPlanDetails = new FormPurchasingPlanDetails();

  public async switchTo(): Promise<void> {
    const appMP = AppMP.getInstance();

    await appMP.abpPlan.click();
    await appMP.abpPlan.btnPurchasingPlan.click();

    await this.waitUILoaded();
  }

  public async waitUILoaded(): Promise<void> {
    await this.formPurchasingPlan.waitUntilPresent();
    await this.formPurchasingPlanDetails.waitUntilPresent();
  }
}
